program Example;

{ This program was written by Peter Lewis, Nov 95 in Metrowerks Pascal }

	uses
		MyNewPreferences, BaseGlobals, MySystemGlobals, 
		MyOOMenus, MyOOAbout, MyStrh,
		MyRequiredEventSupport, PrefCodes,
		IconWindow, MyForeBackground, MyDialogs, 
		MyCleverAlerts, MyStartup,
		MyInternetConfig, MyProcesses;
		
	function DoODoc (var fs: FSSpec): OSErr;
	begin
{$unused(fs)}
		DoODoc := -1;
	end;

	function DoQuit: OSErr;
	begin
		quitNow := true;
		DoQuit := noErr;
	end;

	function HandleMainEvents (var er: eventRecord): boolean;
		const
			WMgrPort = $9DE;
		type
			grafPtrPtr = ^grafPtr;
		var
			b: boolean;
			fw: windowPtr;
	begin
		SetPort(grafPtrPtr(WMgrPort)^);
		if SetOOMenuBar then begin
			DrawMenuBar;
		end;
		fw := FrontWindow;
		b := GetWObject(fw).WaitForEvent(er, 10);
		b := GetWObject(fw).HandleEvents(er);
		SetPort(grafPtrPtr(WMgrPort)^);
		HandleMainEvents := b;
	end;

	const
		url_id = 800;
		
	type
		OurURLs = (OU_None, OU_FTPSite, OU_WebSite, OU_SupportEmail);
	
	var
		last_about_click_count: longInt;
		random_about_index: integer;

	type
		AboutItems = (AI_None, AI_Title, AI_Version, AI_Shareware, AI_Thanks, 
								AI_RatingText, AI_RatingData, AI_Acknowledge, AI_Email, 
								AI_Stariways, AI_Copyright, AI_StairwaysIcon);
								
	type
		MyAboutObject = object(AboutObject)
				function GetString (index: integer): str255;
				override;
				procedure DoItem (item: integer);
				override;
			end;

	procedure MyAboutObject.DoItem (item: integer);
		function Flash(i1,i2,i3:AboutItems):boolean;
		begin
			Flash := TrackItems(window, ord(i1),ord(i2),ord(i3));
		end;
		var
			err:OSErr;
	begin
		SetPort(window);
		err := noErr;
		case AboutItems(item) of
			AI_Title, AI_Version : begin
				if Flash(AI_Title, AI_Version,AI_None) then begin
					err := MyLaunchURL('', GetIndStr(url_id, ord(OU_FTPSite)));
				end;
			end;
			AI_Thanks: begin
				if Flash(AI_Thanks,AI_None,AI_None) then begin
					err := LaunchAppWithHint (app_fs.vRefNum, app_fs.parID, 'Regi','APPL',true);
				end;
			end;
			AI_Email: begin
				if Flash(AI_Email,AI_None,AI_None) then begin
					err := MyLaunchURL('', GetIndStr(url_id, ord(OU_SupportEmail)));
				end;
			end;
			AI_Stariways, AI_Copyright, AI_StairwaysIcon: begin
				if Flash(AI_Stariways, AI_Copyright, AI_StairwaysIcon) then begin
					err := MyLaunchURL('', GetIndStr(url_id, ord(OU_WebSite)));
				end;
			end;
			otherwise begin
				inherited DoItem(item);
			end;
		end;
		if err <> noErr then begin
			CleverParamText(NumToStr(err),'','','');
			CleverNotifyAlert(188);
		end;
	end;

	function MyAboutObject.GetString (index: integer): str255;
		var
			s: str255;
			newrai: integer;
			val: longInt;
	begin
		S := '???';
		case index of
			3:  begin
			end;
			4:  begin
			end;
			5:  begin
			end;
			6:  begin
				prefs.GetTagLong(P_DateStarted, val);
				IUDateString(val, abbrevDate, s);
			end;
			7:  begin
				GetIndString(s, 128, 17 + ord(prefs.GetTagBoolean(P_Paid)));
			end;
			8:  begin
				if last_about_click_count <> about_click_count then begin
					newrai := BAND(Random, $7FFF) mod (CountStrs(132) - 1) + 1;
					if newrai >= random_about_index then begin
						newrai := newrai + 1;
					end;
					random_about_index := newrai;
					last_about_click_count := about_click_count;
				end;
				GetIndString(s, 132, random_about_index);
			end;
			9: begin
			end;
			10: begin
			end;
			otherwise
				s := inherited GetString(index);
		end;
		GetString := s;
	end;

	var
		er: eventRecord;
		dummyb: boolean;
		mainloop_dobj: DObject;
		oe: OSErr;
		my_about_object: MyAboutObject;
		msg: integer;
begin
	InitInForeOrBackground(0, 0, 0, 0);
	HaveResources;
	FixScrap;
	SetCursor(GetCursor(watchCursor)^^);
	InitSystemGlobals;
	InitAppleEvents(nil, DoODoc, nil, DoQuit);
	InitNewPreferences(prefsStrhResID, prefsFolderStrhIndex, prefsNameStrhIndex, our_creator_code);

	StartupIconWindow;
	StartupInternetConfig;
	StartupOOMenus;
	StartupAbout;
	StartupDialogs;
	StartupCleverAlerts;
	
	last_about_click_count := about_click_count - 1;
	ConfigureCleverAlerts(128, 1);
	new(mainloop_dobj);
	ConfigureMainLoop(mainloop_dobj);
	ConfigureFMenus(DoDefaultMenu);
	new(my_about_object);
	ConfigureAbout(my_about_object);
	ConfigureInternetConfig(our_creator_code, true);
	
	oe := Startup(msg);
	if oe = noErr then begin
		while not quitNow do begin
			dummyb := HandleMainEvents(er);
			IdleStartup;
		end;
		FinishStartup;
	end;
end.