unit IconWindow;

interface

	procedure StartupIconWindow;

implementation

	uses
		Icons,Fonts,
		MyOOMainLoop, MyDialogs, MyUtils,MyCursors, MyStartup;

	type
		IconObject = object(DObject)
				procedure DoItem (item: integer);
				override;
			end;

	var
		obj: IconObject;

	function GetId (item: integer): integer;
	begin
		case item of
			1: 
				GetId := 200;
			2: 
				GetId := 201;
			3: 
				GetId := 202;
			4: 
				GetId := 204;
			5: 
				GetId := 205;
			6: 
				GetId := 206;
			otherwise begin
				DebugStr('Strange GetID');
			end;
		end;
	end;

	procedure DrawItem (dlg: DialogPtr; item: integer; highlighted: boolean);
		var
			id: integer;
			icons: handle;
			r, ir: rect;
			name: str255;
			fi: FontInfo;
			junk: OSerr;
			transform: integer;
			pt: Point;
	begin
		SetPort(dlg);
		id := GetId(item);
		junk := GetIconSuite(icons, id, svAllLargeData);
		GetDItemRect(dlg, item, r);
		GetIndString(name, 230, item);
		SetMyFont(MFT_Geneva9);
		GetFontInfo(fi);
		EraseRect(r);
		PenSize(2, 2);
		FrameRoundRect(r, 5, 5);
		PenSize(1, 1);
		ir.left := (r.right + r.left) div 2 - 16;
		ir.top := (r.top + 12);
		ir.right := ir.left + 32;
		ir.bottom := ir.top + 32;
		if highlighted then begin
			transform := ttSelected;
		end else begin
			transform := ttNone;
		end;
		junk := PlotIconSuite(ir, atNone, transform, icons);
		pt.h := (r.right + r.left - StringWidth(name)) div 2;
		pt.v := ir.bottom + 3 + fi.ascent;
		MoveTo(pt.h, pt.v);
		DrawString(name);
		if highlighted then begin
			SetRect(ir, pt.h - 1, pt.v - fi.ascent, pt.h + StringWidth(name) + 1, pt.v + fi.descent + 1);
			HiliteInvertRect(ir);
		end;
	end;

	procedure DrawItemProc (dlg: DialogPtr; item: integer);
	begin
		DrawItem(dlg, item, false);
	end;

	procedure Doit (n: integer);
	begin
		case n of
			1: 
				SysBeep(1);
			2: 
				SysBeep(1);
			3: 
				SysBeep(1);
			4: 
				SysBeep(1);
			5: 
				SysBeep(1);
			6: 
				SysBeep(1);
			otherwise
				DebugStr('Strange Doit');
		end;
	end;


	procedure TrackItem (dlg: DialogPtr; item: integer);
		var
			inside, newinside: boolean;
			pt: Point;
			r: rect;
	begin
		SetPort(dlg);
		GetDItemRect(dlg, item, r);
		inside := false;
		repeat
			GetMouse(pt);
			newinside := PtInRect(pt, r);
			if newinside <> inside then begin
				inside := newinside;
				Drawitem(dlg, item, inside);
			end;
		until not StillDown;
		if inside then begin
			DrawItem(dlg, item, false);
			Doit(item);
		end;
	end;

	procedure IconObject.DoItem (item: integer);
	begin
		if item in [1..6] then begin
			CursorSetProcessing(false);
			TrackItem(window, item);
			CursorSetProcessing(true);
		end else begin
			inherited DoItem(item);
		end;
	end;

	function InitIconWindow(var msg: integer): OSStatus;
		var
			i: integer;
	begin
		msg := msg; { Unused }
		new(obj);
		obj.Create(210);
		for i := 1 to 6 do begin
{$ifc GENERATINGPOWERPC}
			Assert( false );
{$endc}
			SetUserItemProc(obj.window, i, @DrawItemProc);
		end;
		ShowWindow(obj.window);
		InitIconWindow := noErr;
	end;

	procedure StartupIconWindow;
	begin
		SetStartup(InitIconWindow, nil, 0, nil);
	end;
end.