unit PrefCodes;

interface

	uses
		Windows, Types;
		
	const
		prefsStrhResID = 128;
		prefsFolderStrhIndex = -1;
		prefsNameStrhIndex = 1;

	const
		P_Paid = 'Paid';
		P_DateStarted = 'Date';
		P_UsageVersion = 'Usag';

	procedure SetDefaultPrefs;
	function WriteOutPrefCodes: OSErr;
	procedure SaveWindowPosition(save_location:OSType; window:WindowPtr);
	procedure RestoreWindowPosition(save_location:OSType; window:WindowPtr);

implementation

	uses
		TextUtils, MyNewPreferences, MyWindows;

	procedure SaveWindowPosition(save_location:OSType; window:WindowPtr);
		var
			loc:Point;
	begin
		if (window<>nil) then begin
			GetWindowPosition(window,loc);
			prefs.SetTagLong(save_location, loc);
		end;
	end;
	
	procedure RestoreWindowPosition(save_location:OSType; window:WindowPtr);
		var
			loc:Point;
	begin
		if window<>nil then begin
			prefs.GetTagLong(save_location, loc);
			SetWindowPosition(window, loc);
		end;
	end;
	
	procedure SetDefaultPrefs;
		procedure SetDef (code: OSType; def: boolean);
		begin
			if not prefs.ExistsTag(code) then begin
				prefs.SetTagBoolean(code, def);
			end;
		end;
		procedure SetDefStr (code: OSType; def: Str255);
		begin
			if not prefs.ExistsTag(code) then begin
				prefs.SetTagString(code, def);
			end;
		end;
		procedure SetDefLong (code: OSType; def: longint);
		begin
			if not prefs.ExistsTag(code) then begin
				prefs.SetTagLong(code, def);
			end;
		end;
		var
			date: UInt32;
			s: Str255;
	begin
		SetDef(P_Paid, false);

		if not prefs.ExistsTag(P_DateStarted) then begin
			GetDateTime(date);
			prefs.SetTagLong(P_DateStarted, date);
		end;
		prefs.SetTagLong(P_UsageVersion, 1);
		GetIndString(s, 140, 1);
		if s = '' then begin
			prefs.SetTagBoolean(P_Paid, true);
		end;
	end;

	function WriteOutPrefCodes: OSErr;
	begin
		WriteOutPrefCodes := WritePrefsData;
	end;

end.
